This repository has been archived on 2023-11-20. You can view files and clone it, but cannot push or open issues or pull requests.
foam-extend4.1-coherent-io/bin/foamUpdateCaseFileHeader

157 lines
4.2 KiB
Text
Raw Normal View History

#!/bin/sh
#------------------------------------------------------------------------------
# ========= |
2015-05-17 13:34:58 +00:00
# \\ / F ield | foam-extend: Open Source CFD
# \\ / O peration | Version: 4.1
2016-06-20 15:00:40 +00:00
# \\ / A nd | Web: http://www.foam-extend.org
# \\/ M anipulation | For copyright notice see file Copyright
#------------------------------------------------------------------------------
# License
2016-06-20 15:00:40 +00:00
# This file is part of foam-extend.
#
2016-06-20 15:00:40 +00:00
# foam-extend is free software: you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the
2013-12-11 16:09:41 +00:00
# Free Software Foundation, either version 3 of the License, or (at your
# option) any later version.
#
2016-06-20 15:00:40 +00:00
# foam-extend is distributed in the hope that it will be useful, but
2013-12-11 16:09:41 +00:00
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
2016-06-20 15:00:40 +00:00
# along with foam-extend. If not, see <http://www.gnu.org/licenses/>.
#
# Script
# foamUpdateCaseFileHeader
#
# Description
# Updates the header of application files.
# By default, writes current version in the header.
# Alternatively version can be specified with -v option.
# Also removes consecutive blank lines from file.
#
#------------------------------------------------------------------------------
2010-05-27 10:48:11 +00:00
foamVersion=$WM_PROJECT_VERSION
2010-05-27 10:48:11 +00:00
usage() {
cat<<USAGE
Usage: ${0##*/} [OPTION] <file1> ... <fileN>
options:
-v VER specifies the version to be written in the header
-h help
Updates the header of application files and removes consecutive blank lines.
By default, writes current OpenFOAM version in the header.
An alternative version can be specified with the -v option.
USAGE
exit 1
}
2010-05-27 10:48:11 +00:00
printHeader() {
cat<<HEADER
/*--------------------------------*- C++ -*----------------------------------*\\
| ========= | |
2013-12-11 16:09:41 +00:00
| \\\\ / F ield | foam-extend: Open Source CFD |
| \\\\ / O peration | Version: ${foamVersion} |
2015-05-17 13:34:58 +00:00
| \\\\ / A nd | Web: http://www.foam-extend.org |
2016-06-21 12:50:08 +00:00
| \\\\/ M anipulation | For copyright notice see file Copyright |
\\*---------------------------------------------------------------------------*/
FoamFile
{
version 2.0;
2010-11-24 20:47:45 +00:00
format ${FORMAT};
class ${CLASS};
HEADER
if [ -n "${NOTE}" ];
then
cat<<HEADER
note ${NOTE};
HEADER
fi
if [ -n "${LOCATION}" ];
then
cat<<HEADER
location ${LOCATION};
HEADER
fi
cat<<HEADER
object ${OBJECT};
}
2010-05-27 10:48:11 +00:00
HEADER
}
2010-05-27 10:48:11 +00:00
#
# extract attribute '$1' from file '$2'
#
FoamFileAttribute() {
sed -n -e 's/[ ;]*$//' -e "s/^ *$1 *//p" $2
}
#
# OPTIONS
#
2010-05-27 10:48:11 +00:00
opts=$(getopt hv: $*)
if [ $? -ne 0 ]
then
echo "Aborting due to invalid option"
2010-05-27 10:48:11 +00:00
usage
fi
2010-05-27 10:48:11 +00:00
eval set -- '$opts'
while [ "$1" != "--" ]
do
case $1 in
2010-05-27 10:48:11 +00:00
-v)
foamVersion=$2
shift
;;
-h)
usage
;;
esac
shift
done
shift
2010-05-27 10:48:11 +00:00
[ $# -ge 1 ] || usage
# constant width for version
2013-12-11 16:09:41 +00:00
foamVersion=$(printf %-33s $foamVersion)
2010-05-27 10:48:11 +00:00
#
# MAIN
#
2010-05-27 10:48:11 +00:00
for caseFile
do
2010-11-24 20:47:45 +00:00
if [ ! -x "$caseFile" ] && (grep "^ *FoamFile" $caseFile >/dev/null 2>&1)
2010-05-27 10:48:11 +00:00
then
echo "Updating case file: $caseFile"
sed -n '/FoamFile/,/}/p' $caseFile > FoamFile.tmp
FORMAT=$(FoamFileAttribute format FoamFile.tmp)
CLASS=$(FoamFileAttribute class FoamFile.tmp)
2010-11-24 20:47:45 +00:00
NOTE=$(FoamFileAttribute note FoamFile.tmp)
LOCATION=$(FoamFileAttribute location FoamFile.tmp)
2010-05-27 10:48:11 +00:00
OBJECT=$(FoamFileAttribute object FoamFile.tmp)
2010-11-24 20:47:45 +00:00
printHeader > FoamFile.tmp
sed '1,/}/d' $caseFile | sed '/./,/^$/!d' | sed 's/ *$//g' >> FoamFile.tmp
#sed '1,/}/d' $caseFile >> FoamFile.tmp
2010-05-27 10:48:11 +00:00
# use cat to avoid removing/replace soft-links
[ -s FoamFile.tmp ] && cat FoamFile.tmp >| $caseFile
rm -f FoamFile.tmp 2>/dev/null
else
echo " Invalid case file: $caseFile" 1>&2
fi
done
#------------------------------------------------------------------------------